import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Nice things that can be done with lines intersection calc and rays :-)
// Yes, there are 4 orange rays in the "wrong" direction.
// This is correct as the black points are the starting points
// and the others give the direction of the ray.

hyperbolic_point P = hyperbolic_point(1, 0);

hyperbolic_point A = hyperbolic_point(1,120);
hyperbolic_point B = hyperbolic_point(1,240);
hyperbolic_line l = hyperbolic_line(A, B);

int many = 42;
hyperbolic_point Q;
hyperbolic_line L;
hyperbolic_point I;
hyperbolic_ray R;

for (int j = 1; j < many+1; ++j) {
    Q = hyperbolic_point(1, j*360/(many+1));
    L = hyperbolic_line(P, Q);
    I = intersection(L, l);

    if ( !I.is_invalid() ) {
        R = hyperbolic_ray(I, P);
        draw(R, blue);
        R = hyperbolic_ray(I, Q);
        draw(R, orange);
        dot(Q, orange);
        dot(I, black);
    } else {
        draw(L, blue);
        dot(Q, blue);
    }
}

dot(A, gray);
dot(B, gray);
draw(l, black);
dot(P, blue);
dot((0,0), black);

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
